/**
 */
package paperresearcherrosemodel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * An architectural view that describes the concurrent aspect of the system: tasks (processes) and their interactions.
 * <!-- end-model-doc -->
 * @see paperresearcherrosemodel.PaperresearcherrosemodelFactory
 * @model kind="package"
 * @generated
 */
public interface PaperresearcherrosemodelPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "paperresearcherrosemodel";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///paperresearcherrosemodel.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "paperresearcherrosemodel";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PaperresearcherrosemodelPackage eINSTANCE = paperresearcherrosemodel.impl.PaperresearcherrosemodelPackageImpl.init();

	/**
	 * The meta object id for the '{@link paperresearcherrosemodel.impl.PaperImpl <em>Paper</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see paperresearcherrosemodel.impl.PaperImpl
	 * @see paperresearcherrosemodel.impl.PaperresearcherrosemodelPackageImpl#getPaper()
	 * @generated
	 */
	int PAPER = 0;

	/**
	 * The feature id for the '<em><b>Title</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAPER__TITLE = 0;

	/**
	 * The feature id for the '<em><b>Word Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAPER__WORD_COUNT = 1;

	/**
	 * The feature id for the '<em><b>Student Paper</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	Researcher PAPER_REFEREE=null;
	int PAPER__STUDENT_PAPER = 2;

	/**
	 * The number of structural features of the '<em>Paper</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PAPER_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link paperresearcherrosemodel.impl.ResearcherImpl <em>Researcher</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see paperresearcherrosemodel.impl.ResearcherImpl
	 * @see paperresearcherrosemodel.impl.PaperresearcherrosemodelPackageImpl#getResearcher()
	 * @generated
	 */
	int RESEARCHER = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESEARCHER__NAME = 0;

	/**
	 * The feature id for the '<em><b>Is Student</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESEARCHER__IS_STUDENT = 1;

	/**
	 * The number of structural features of the '<em>Researcher</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESEARCHER_FEATURE_COUNT = 2;


	/**
	 * Returns the meta object for class '{@link paperresearcherrosemodel.Paper <em>Paper</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Paper</em>'.
	 * @see paperresearcherrosemodel.Paper
	 * @generated
	 */
	EClass getPaper();

	/**
	 * Returns the meta object for the attribute '{@link paperresearcherrosemodel.Paper#getTitle <em>Title</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Title</em>'.
	 * @see paperresearcherrosemodel.Paper#getTitle()
	 * @see #getPaper()
	 * @generated
	 */
	EAttribute getPaper_Title();

	/**
	 * Returns the meta object for the attribute '{@link paperresearcherrosemodel.Paper#getWordCount <em>Word Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Word Count</em>'.
	 * @see paperresearcherrosemodel.Paper#getWordCount()
	 * @see #getPaper()
	 * @generated
	 */
	EAttribute getPaper_WordCount();

	/**
	 * Returns the meta object for the attribute '{@link paperresearcherrosemodel.Paper#getStudentPaper <em>Student Paper</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Student Paper</em>'.
	 * @see paperresearcherrosemodel.Paper#getStudentPaper()
	 * @see #getPaper()
	 * @generated
	 */
	EAttribute getPaper_StudentPaper();

	/**
	 * Returns the meta object for class '{@link paperresearcherrosemodel.Researcher <em>Researcher</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Researcher</em>'.
	 * @see paperresearcherrosemodel.Researcher
	 * @generated
	 */
	EClass  getPaper_Referee();
	EClass getResearcher();

	/**
	 * Returns the meta object for the attribute '{@link paperresearcherrosemodel.Researcher#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see paperresearcherrosemodel.Researcher#getName()
	 * @see #getResearcher()
	 * @generated
	 */
	EAttribute getResearcher_Name();

	/**
	 * Returns the meta object for the attribute '{@link paperresearcherrosemodel.Researcher#getIsStudent <em>Is Student</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Student</em>'.
	 * @see paperresearcherrosemodel.Researcher#getIsStudent()
	 * @see #getResearcher()
	 * @generated
	 */
	EAttribute getResearcher_IsStudent();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PaperresearcherrosemodelFactory getPaperresearcherrosemodelFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link paperresearcherrosemodel.impl.PaperImpl <em>Paper</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see paperresearcherrosemodel.impl.PaperImpl
		 * @see paperresearcherrosemodel.impl.PaperresearcherrosemodelPackageImpl#getPaper()
		 * @generated
		 */
		EClass PAPER = eINSTANCE.getPaper();

		/**
		 * The meta object literal for the '<em><b>Title</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PAPER__TITLE = eINSTANCE.getPaper_Title();

		/**
		 * The meta object literal for the '<em><b>Word Count</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PAPER__WORD_COUNT = eINSTANCE.getPaper_WordCount();

		/**
		 * The meta object literal for the '<em><b>Student Paper</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PAPER__STUDENT_PAPER = eINSTANCE.getPaper_StudentPaper();

		/**
		 * The meta object literal for the '{@link paperresearcherrosemodel.impl.ResearcherImpl <em>Researcher</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see paperresearcherrosemodel.impl.ResearcherImpl
		 * @see paperresearcherrosemodel.impl.PaperresearcherrosemodelPackageImpl#getResearcher()
		 * @generated
		 */
		EClass RESEARCHER = eINSTANCE.getResearcher();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESEARCHER__NAME = eINSTANCE.getResearcher_Name();

		/**
		 * The meta object literal for the '<em><b>Is Student</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RESEARCHER__IS_STUDENT = eINSTANCE.getResearcher_IsStudent();

	}

} //PaperresearcherrosemodelPackage
