package paperresearcherrosemodel.actions;

import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.commands.contexts.Context;
import org.eclipse.core.internal.preferences.InstancePreferences;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EEnumLiteral;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EParameter;
import org.eclipse.emf.ecore.EStructuralFeature;
/*import org.eclipse.emf.examples.extlibrary.Book;
import org.eclipse.emf.examples.extlibrary.BookCategory;
import org.eclipse.emf.examples.extlibrary.EXTLibraryFactory;
import org.eclipse.emf.examples.extlibrary.EXTLibraryPackage;
import org.eclipse.emf.examples.extlibrary.Library;
import org.eclipse.emf.examples.extlibrary.Writer;*/
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ocl.OCL;
import org.eclipse.ocl.ParserException;
import org.eclipse.ocl.Query;
import org.eclipse.ocl.expressions.OCLExpression;
import org.eclipse.ocl.expressions.OperationCallExp;
import org.eclipse.ocl.helper.Choice;
import org.eclipse.ocl.helper.ConstraintKind;
import org.eclipse.ocl.helper.OCLHelper.*;
//import org.eclipse.ocl.internal.helper.*;// helper.OCLHelper;
import org.eclipse.ocl.utilities.AbstractVisitor;
import org.eclipse.ocl.utilities.ExpressionInOCL;
import org.eclipse.ocl.utilities.PredefinedType;
import org.eclipse.ocl.utilities.Visitable;
import org.eclipse.ocl.helper.*;
import org.eclipse.ocl.*;
import org.eclipse.ocl.internal.helper.HelperUtil.*;
//import org.eclipse.ocl.internal.helper.HelperUtil;

//import org.eclipse.ocl.internal.helper.HelperUtil.*;
//import org.eclipse.ocl.internal.helper.HelperUtil.parseQuery();
//org.eclipse.ocl.internal.helper.HelperUtil.parseQuery()
import org.eclipse.ocl.ecore.*; // for Constraint and EcoreEnvironmentFactory
import org.eclipse.ocl.ecore.OCL.Helper;

import paperresearcherrosemodel.Paper;
import paperresearcherrosemodel.PaperresearcherrosemodelFactory;
import paperresearcherrosemodel.PaperresearcherrosemodelPackage;
import paperresearcherrosemodel.Researcher;

/**
 * Our sample action implements workbench action delegate.
 * The action proxy will be created by the workbench and
 * shown in the UI. When the user tries to use the action,
 * this delegate will be created and execution will be 
 * delegated to it.
 * @see IWorkbenchWindowActionDelegate
 */
public class SampleAction implements IWorkbenchWindowActionDelegate {
	private IWorkbenchWindow window;
	/**
	 * The constructor.
	 */
	public SampleAction() {
	}

	/**
	 * The action has been activated. The argument of the
	 * method represents the 'real' action sitting
	 * in the workbench UI.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action) {
		MessageDialog.openInformation(
			window.getShell(),
			"Library",
			"Hello, Eclipse world");
		
		//-----------------
		boolean valid;
		 OCLExpression<EClassifier> query = null;

		    
		     OCL<?, EClassifier, EOperation, EStructuralFeature, EEnumLiteral, EParameter, ?, CallOperationAction, ?, Constraint, EClass, EObject> ocl;
		     ocl = OCL.newInstance(EcoreEnvironmentFactory.INSTANCE);
		     
		     // create an OCL helper object
		     OCLHelper<EClassifier,?, ?, Constraint> helper = ocl.createOCLHelper();
		 
		    
		     
		   //start PAPER classfier *********************************************  
		     // set the OCL context classifier for PAPER--------------------
		     helper.setContext(PaperresearcherrosemodelPackage.Literals.PAPER);
		     
			     
		
		

		// create an extent map for 'submission'
		 Map<EClass, Set<? extends EObject>> extents = new HashMap<EClass, Set<? extends EObject>>();
		 Set<Paper> submission = new HashSet<Paper>(); 
		 
		 extents.put(PaperresearcherrosemodelPackage.Literals.PAPER, submission);

		 // tell the OCL environment what our classifier extents are
		 ocl.setExtentMap(extents);

		 Paper paper = PaperresearcherrosemodelFactory.eINSTANCE.createPaper();

		
		 paper.setTitle("uml-ocl verification");
		 paper.setWordCount(5000);
		 paper.setStudentPaper(true);
		 submission.add(paper);
		 

		
		// create an extent map for 'manuscript'
			
				 Set<Paper> manuscript = new HashSet<Paper>(); 
				 
				 extents.put(PaperresearcherrosemodelPackage.Literals.PAPER, manuscript);

				 // tell the OCL environment what our classifier extents are
				 ocl.setExtentMap(extents);

				

			
				 paper.setTitle("uml-ocl verification");
				 paper.setWordCount(5000);
				 paper.setStudentPaper(true);
				 manuscript.add(paper);
		 //end PAPER classfier **************************************
	
	//start RESEARCHER classfier *********************************************
				 helper.setContext(PaperresearcherrosemodelPackage.Literals.PAPER);
			     
			
			     
			
			

			// create an extent map for 'submission'
			
			 Set<Researcher> referee = new HashSet<Researcher>(); 
			 
			 extents.put(PaperresearcherrosemodelPackage.Literals.RESEARCHER, referee);

			 // tell the OCL environment what our classifier extents are
			 ocl.setExtentMap(extents);

			 Researcher researcher = PaperresearcherrosemodelFactory.eINSTANCE.createResearcher();

			
			 researcher.setName("reza");
			 researcher.setIsStudent(false);
			 referee.add(researcher);
		
			
			// create an extent map for 'manuscript'
				
					 Set<Researcher> author = new HashSet<Researcher>(); 
					 
					 extents.put(PaperresearcherrosemodelPackage.Literals.RESEARCHER,author);

					 // tell the OCL environment what our classifier extents are
					 ocl.setExtentMap(extents);

				

					
					 researcher.setName("reza");
					 researcher.setIsStudent(false);
					 author.add(researcher);
				 
    //end RESEARCHER classfier ********************************************* 			 
		 
	 //new project is started in date 1391/08/27------------------------------------

					 helper.setContext(PaperresearcherrosemodelPackage.Literals.PAPER);
				     
				  
				     try {
				    
				    //1-	query= helper.createQuery("self.wordCount<10000");
				    	 query= helper.createQuery("self.referee->forAll(r| not r.isStudent)");
						
					} catch (ParserException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				     vordCount_attributeCHK visitor=new vordCount_attributeCHK(
				    	PaperresearcherrosemodelPackage.Literals.PAPER__WORD_COUNT);
				     
				   System.out.println(
						     "Number of accesses to the 'Book::title' attribute: " + query.accept(visitor));
				 
				     }
	//AbstractVisitor is imported org.eclipse.ocl.utilities.AbstractVisitor;  
    class vordCount_attributeCHK extends AbstractVisitor<Boolean,
 	EClassifier, EOperation, EStructuralFeature, EEnumLiteral,
	EParameter, EObject, EObject, EObject, Constraint> {
    	
    	 private  final EAttribute attribute;
    	 public EObject currentObject;
    	 public vordCount_attributeCHK(EAttribute attribute)
    	 {
    		 super(false);
    		 this.attribute=attribute;
    		 currentObject=attribute.eContainer();// return Paper
    		
    	 }
    	 
    	   protected Boolean handlePropertyCallExp(org.eclipse.ocl.expressions.PropertyCallExp<EClassifier, EStructuralFeature> callExp,
    			   Boolean sourceResult, List<Boolean> sourceResults) {
    		
    		            
    		            String a;
    			        if ( callExp.getReferredProperty() == attribute) {
    			        	     attribute.getName();
    			        }
    			        /*
    			        Integer result = sourceResult;
    			        OCLExpression<EClassifier> source = callExp.getSource();

    			        EStructuralFeature property = callExp.getReferredProperty();

    			      //  generateProperyGetterString(source, property, result);
    			        return super.handlePropertyCallExp(callExp, sourceResult, qualifierResults);
    			        */
    			        return result;
    			    }
 
    		
    		
    		public Boolean visitOperationCallExp(OperationCallExp<EClassifier, EOperation> callExp) {
    			//callEXP:=self.wordCount.<(10000)
    			//source=callExp.getSource():=self.wordCount 
    	        OCLExpression<EClassifier> source = callExp.getSource();
    	        Boolean sourceResult = safeVisit(source);
                int opcode=callExp.getOperationCode();
    	    	
    	    	switch(opcode)
    	    	{
    	    		case PredefinedType.LESS_THAN :
    	    			
    	    		    Paper paper = PaperresearcherrosemodelFactory.eINSTANCE.createPaper();
    	    		    paper.setWordCount(5);
    	    		    if(paper.getWordCount() < 10000 )
    	    			  result=true;
    	    		    break;
    	    		case PredefinedType.GREATER_THAN :
    	    			int b;
    	    			break;
    	    		
    	    	}
    	        List<Boolean> argumentResults;
    	        List<OCLExpression<EClassifier>> arguments = callExp.getArgument();
    	      
    	        if (arguments.isEmpty()) {
    	            argumentResults = Collections.emptyList();
    	        } else {
    	            argumentResults = new java.util.ArrayList<Boolean>(arguments.size());
    	            for (OCLExpression<EClassifier> qual : arguments) {
    	                argumentResults.add(safeVisit(qual));
    	                
    	            }
    	        }
    	        
    	        return handleOperationCallExp(callExp, sourceResult, argumentResults);
    		}
    	    
    	    /**
    	     * Visits the specified operation call with the results of visiting
    	     * its source and arguments (if any).
    	     * 
    	     * @param callExp the operation call expression
    	     * @param sourceResult the result of visiting the expression's source
    	     * @param argumentResults the results of visiting the expression's
    	     *     arguments, or an empty list if there are no arguments
    	     * 
    	     * @return the accumulated {@link #result}, by default
    	     * 
    	     * @see #visitOperationCallExp(OperationCallExp)
    	     */
    		
    	    protected Boolean handleOperationCallExp(OperationCallExp<EClassifier, EOperation> callExp,
    	    		Boolean sourceResult, List<Boolean> argumentResults) {
int opcode=callExp.getOperationCode();
    	    	
    	    	switch(opcode)
    	    	{
    	    		case PredefinedType.LESS_THAN :
    	    			//getPaper_Title
    	    			
    	    		Paper paper = PaperresearcherrosemodelFactory.eINSTANCE.createPaper();
    	    		paper.setWordCount(5);
    	    			//p1.setWordCount(3);
    	    			//setWordCount(3);//source.getType()= type of WordCount that is integer
    	    		if(paper.getWordCount()< 10000 )
    	    			result=true;
    	    			break;
    	    		case PredefinedType.GREATER_THAN :
    	    			int b;
    	    			break;
    	    		
    	    	}
    	    	
    	   
    	        return result;
    	    }
    } 
         
        
		//end project is started in date 1391/08/27-------------------------------------

					 
	

	/**
	 * Selection in the workbench has been changed. We 
	 * can change the state of the 'real' action here
	 * if we want, but this can only happen after 
	 * the delegate has been created.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

	/**
	 * We can use this method to dispose of any system
	 * resources we previously allocated.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose() {
	}

	/**
	 * We will cache window object in order to
	 * be able to provide parent shell for the message dialog.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}
}